#include <iostream>
#include <cmath>

#define M_PI 3.1415926535897932384626433832795

using namespace std;

int xa,ya,v1,k1,xb,yb,v2,k2;

int pt;

int main()
{
	scanf("%d %d %d %d %d %d %d %d",&xa,&ya,&v1,&k1,&xb,&yb,&v2,&k2);
	scanf("%d",&pt);
	double r1=sqrt(xa*xa+ya*ya);
	double r2=sqrt(xb*xb+yb*yb);
	double t1=(double)v1*(double)k1/r1;
	double t2=(double)v2*(double)k2/r2;
	t1*=-1;
	t2*=-1;
	
	double al,bt;
	double t=t1-t2;
	
	if(xa==0)
	{
		if(ya>0) al=M_PI/2.0;
		else al=3.0*M_PI/2.0;
	}
	else
	{
		if(ya==0) al=0;
		else{
		al=atan(ya/xa);
		if(xa<0) al+=M_PI;}
	}

	if(xb==0)
	{
		if(yb>0) bt=M_PI/2.0;
		else bt=3.0*M_PI/2.0;
	}
	else
	{	
		if(yb==0) bt=0;
		else{
		bt=atan(yb/xb);
		if(xb<0) bt+=M_PI;}
	}
	if(al<0.0) al+=2.0*M_PI;
	if(bt<0.0) bt+=2.0*M_PI;
	
	
	double u=bt-al;
	if(t<0) {t*=-1.0;u*=-1.0;}
	int k=-u/(2.0*M_PI);
	while(k*2.0*M_PI+u < 0.0) k++;
	k+=(pt-1);
	int ans=(int)((k*2.0*M_PI+u)/t);
	printf("%d\n",ans);
		
	return 0;
}