#include <iostream>
#include <cmath>
using namespace std;

const double Pi = 3.1415926535, Pi2 = 6.2831853071;

int main(){
    double x1, y1, x2, y2, v1, v2, d1, d2, r1, r2, w1, w2, f1, f2, w, f, t;
    double k;
    cin >> x1 >> y1 >> v1 >> d1;
    cin >> x2 >> y2 >> v2 >> d2;
    cin >> k;;
    r1 = sqrt(x1*x1 + y1*y1);
    r2 = sqrt(x2*x2 + y2*y2);
    w1 = d1*v1/r1;
    w2 = d2*v2/r2;
    
    //cout << w1 << ' ' << w2 << endl;
    
    f1 = atan2(y1, x1);
    f2 = atan2(y2, x2);
    f = abs(f2 - f1);
    
    if(d1 < 0 && d2 < 0)
        w = w1 - w2;
    else if(d1 > 0 && d2 < 0)
        w = -w1 - w2;
    else if(d1 < 0 && d2 > 0)
        w = w1 + w2;
    else if(d1 > 0 && d2 > 0)
        w = w2 - w1;
    
    //cout << f << ' ' << w << endl;
    if(f == 0.0 || f == Pi2){
        f = 0;
        t = (k-1.0)*Pi2/w;
        cout << (int)t << endl;
        return 0;
    }
    
    if(w > 0){
        if(0.0 < f && f < Pi2){
        t = (k*Pi2 - f)/w;
        cout << (int)t << endl;
        return 0;    
    }
    }else{
        if(0.0 < f && f > Pi2){
            t =(-k*Pi2 - f)/w;
            cout << (int)t << endl;
            return 0;     
        }    
    }
       
    return 0;    
}
