#include <stdio.h>
#include <string>
using namespace std;

int N, M;
int R[501][501];

void putnextline()
{
     bool impossible[502][502];
     int destroyright[502];
     memset(impossible, 0, sizeof(impossible));
     
     for (int i = 0; i < N; i++) 
      for (int j = 0; j < M; j++)
       impossible[ R[i][j]-1 ][j] = 1;
          
     for (int i = 0; i < M; i++) destroyright[i] = M-N;
     
     for (int j = 0; j < M; j++)
     {
         int mindestr = 501, mindestroyer;
         for (int i = 0; i < M; i++) if (!impossible[i][j])
         {
             //printf("%d: %d\n", i+1, hold[i]); 
             if (destroyright[i] < mindestr) mindestr = destroyright[i], mindestroyer = i;
         }
         //printf("\n");
         
         R[N][j] = mindestroyer+1;
         
         for (int i = 0; i < M; i++) if (!impossible[i][j]) destroyright[i]--;
         
         for (int j1 = j+1; j1 < M; j1++) if (!impossible[mindestroyer][j1])
          impossible[mindestroyer][j1] = 1;
     }
     N++;
}
int main()
{
   scanf("%d%d", &N, &M);
   for (int i = 0; i < N; i++) for (int j = 0; j < M; j++) scanf("%d", &R[i][j]);
   while (N != M) 
    putnextline();
   printf("%d\n",N);
   for (int i = 0; i < N; i++)
   {
         printf("%d", R[i][0]);
         for (int j = 1; j < M; j++)
          printf(" %d", R[i][j]);
         printf("\n"); 
   }
   return 0;
}
