#include <iostream>
#include <math.h>
#define eps 1e-9
#define PI 3.1415926535897932384626433832795
using namespace std;

bool eq(double a, double b)
{
     return fabs(a-b) < eps;
}

int main()
{ 
    int x1, y1, v1, d1;
    int x2, y2, v2, d2;
    int k;
    cin >> x1 >> y1 >> v1 >> d1 >> x2 >> y2 >> v2 >> d2;
    cin >> k;
    
    double angle1 = atan2(y1, x1);
    double angle2 = atan2(y2, x2);
    double V1 = ((double)v1/(PI*2*sqrt(y1*y1+x1*x1)))*PI*2;
    double V2 = ((double)v2/(PI*2*sqrt(y2*y2+x2*x2)))*PI*2;
    
    //cout << V1 << " " << V2 << endl;
    if (d1 != d2)
    {
           if (d1 < d2) swap(angle1, angle2), swap(V1, V2), swap(d1, d2);
           if (angle2 > angle1 + eps) angle1 += PI*2;
           double meettime = (angle1 - angle2)/(V1 + V2);
           double timeforone = (PI*2)/(V1+V2);
           cout << (int)(timeforone*(k-1) + meettime + eps) << endl;
    }
    else
    {
         /*
         swap(V1, V2);
         if (d1 == -1) d1 = d2 = 1;
         else d1 = d2 = -1;*/
         if (d1 == -1) swap(V1, V2);
         if (angle1 < angle2 - eps) swap(angle1, angle2), swap(V1, V2);
         //cout << angle1 << " " << angle2 << endl;
         if (V2 > V1)
         {
                if (!eq(angle1, angle2)) angle1 -= PI*2;
                swap(angle1, angle2), swap(V1, V2);
         }
         double meettime = (angle1 - angle2)/(V1 - V2);
         double timeforone = (PI*2)/(V1-V2);
         cout << (int)( timeforone*(k-1) + meettime + eps) << endl;
    }
    return 0;
}
