
#include <ctime>
#include <iostream>
using namespace std;

const int MAX_NODES = 1 << 14;

int N;
int best = 0;
int mark[MAX_NODES];
int path[MAX_NODES], path2[MAX_NODES];

clock_t start;

/*
bool can(int at, int more) {
    if (more == 0)
        return true;
    for (int i = 0; i < N; ++i)
        if (!mark[at ^ (1 << i)]) {
            for (int j = 0; j < N; ++j)
                if (i != j)
                    ++mark[at ^ (1 << j)];
            ++mark[at];
            if (can(at ^ (1 << i), more - 1))
                return true;
            --mark[at];
            for (int j = 0; j < N; ++j)
                if (i != j)
                    --mark[at ^ (1 << j)];
        }
    return false;
}*/

void rec(int at, int x = 0) {
    path[x] = at;
    if (best < x + 1) {
        best = x + 1;
        for (int i = 0; i < best; ++i)
            path2[i] = path[i];
    }
    bool ok = ((0.0 + clock() - start) / CLOCKS_PER_SEC <= 4.5);
    for (int i = 0; i < N && ok; ++i)
        if (!mark[at ^ (1 << i)]) {
            for (int j = 0; j < N; ++j)
                if (i != j)
                    ++mark[at ^ (1 << j)];
            ++mark[at];
            rec(at ^ (1 << i), x + 1);
            --mark[at];
            for (int j = 0; j < N; ++j)
                if (i != j)
                    --mark[at ^ (1 << j)];
        }
}

int main() {
    cin >> N;
    start = clock();
    rec(0);
    printf("%d\n", best);
    for (int i = 0; i < best; ++i) {
        for (int j = 0; j < N; ++j)
            printf("%d ", ((path2[i] >> (N - 1 - j)) & 1));
        puts("");
    }
    return 0;
}
