#include <cstdio>
#include <cstdlib>
#include <ctime>

const int MAX_N = 500 + 5;

int M, N;
int a[MAX_N][MAX_N];
bool used_col[MAX_N][MAX_N];
bool used_row[MAX_N][MAX_N];
int cur[MAX_N];

void print()
{
	printf("%d\n", N);
	for(int i = 0; i < N; i ++)
	{
		for(int j = 0; j + 1 < N; j ++)
			printf("%d ", a[i][j]);
		printf("%d\n", a[i][N - 1]);
	}
}

void rec(int x, int y)
{
	if(y == N)	y = 0, x ++;
	if(x == N)
	{
		print();
		exit(0);
	}
	for(int i = 1; i <= N; i ++)	if(!used_col[y][i] && !used_row[x][i])
	{
		used_col[y][i] = 1;
		used_row[x][i] = 1;
		a[x][y] = i;
		rec(x, y + 1);
		used_col[y][i] = 0;
		used_row[x][i] = 0;
	}
}

int main()
{
	scanf("%d %d", &M, &N);
	for(int i = 0; i < M; i ++)
		for(int j = 0; j < N; j ++)
		{
			scanf("%d", &a[i][j]);
			used_col[j][a[i][j]] = 1;
		}
	if((N * (N - M) < 20 * 20 && (M + 1 != N)) || (N - M < 6))	rec(M, 0);
	for(int i = M; i < N; i ++)
		for(int j = 0; j < N; j ++)
		{
			int k;
			for(k = 1; cur[k] == i || used_col[j][k]; k ++);
			a[i][j] = k;
			used_col[j][k] = 1;
			cur[k] = i;
		}
	print();
    return 0;
}
