#include <iostream>
#include <cmath>

using namespace std;

struct planet
{
 int x,y;
 int v,d;
 double gps;      
};

double dist(int x1,int y1,int x2,int y2)
{ return sqrt( (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2) ); }

double cross(int x1,int y1,int x2,int y2,int x3,int y3)
{ return (x2-x1)*(y3-y1)-(y2-y1)*(x3-x1); }

planet a,b;
int k;

int main()
{
 cin>>a.x>>a.y>>a.v>>a.d; a.gps=dist(a.x,a.y,0,0)/(double) a.v;
 cin>>b.x>>b.y>>b.v>>b.d; b.gps=dist(b.x,a.y,0,0)/(double) b.v;
 cin>>k;
 
 double s1=cross(0,0,1,0,a.x,a.y)/dist(0,0,1,0);
 s1/=dist(0,0,a.x,a.y);
 double angle1=asin(s1)*180.0/M_PI;
 if(angle1<0.0)    angle1+=360.0;
 if(angle1>=360.0) angle1-=360.0;
 
 double s2=cross(0,0,1,0,b.x,b.y)/dist(0,0,1,0);
 s1/=dist(0,0,b.x,b.y);
 double angle2=asin(s2)*180.0/M_PI;
 if(angle2<0.0)    angle2+=360.0;
 if(angle2>=360.0) angle2-=360.0;
 
 if(angle1==angle2 && k==1) { cout<<0<<endl; return 0; }
 
 int t=1;
 double pa1=angle1;
 double pa2=angle2;
 while(k&& t<100000)
 {
  double a1=-a.d*t*a.gps+angle1; while(a1<0) a1+=360; while(a1>=360) a1-=360;
  double a2=-b.d*t*b.gps+angle2; while(a2<0) a2+=360; while(a2>=360) a2-=360;
  
  if(pa1>a1) a1+=360;
  if(pa2>a2) a2+=360;
  
  if( (pa2<a1 && a1<a2) || (pa1<a2 && a2<a1) ) k--;
  while(a1<0) a1+=360; while(a1>=360) a1-=360;
  while(a2<0) a2+=360; while(a2>=360) a2-=360;
  t++;       
 }
 if(t==100000) cout<<112<<endl;
 else cout<<t-1<<endl;
 
 return 0;
}
