#include <cstdio>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 9;

int n , m;
int u[MAXN][MAXN];
int f;
pair < int , int > heap[MAXN];
int idx[MAXN];
int cnt[MAXN];
int used[MAXN];

void read() {
	int i , j;
	int x;
	
	scanf ( "%d%d" , &n , &m );
	
	printf ( "%d\n" , m );
	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++) {
			scanf ( "%d" , &x );
			
			u[j][x] = 1;
			printf ( "%d" , x );
			if ( j == m ) printf ( "\n" );
			else printf ( " " );
		}
}

void myswap ( int x , int y ) {
	swap ( heap[x] , heap[y] );
	swap ( idx[x] , idx[y] );
}

void pop_up ( int i ) {
	while ( i != 1 ) {
		if ( heap[i].first < heap[i / 2].first )
			myswap ( i , i / 2 );
		else
			break;
		i /= 2;
	}
}

void del_top() {
	int i = 1;
	
	while ( 2 * i <= f ) {
	//	printf ( "%d    %d %d\n" , i , heap[2 * i].second , heap[2 * i + 1].second );
		if ( 2 * i + 1 > m || heap[2 * i].first < heap[2 * i + 1].first ) {
			myswap ( i , 2 * i );
			i = i * 2; 
		} else {
			myswap ( i , 2 * i + 1 );
			i = i * 2 + 1;
		}
	}
}

void solve() {
	int i , j;
	
	while ( n != m ) {
		f = 0;
		for (i = 1; i <= m; i++) {
			used[i] = 0;
			idx[i] = f + 1;
			heap[ ++ f ] = make_pair ( m - n , i );
			pop_up ( f );
			cnt[i] = m - n;
		}
		++ n;
			
		for (int iter = m; iter--; ) {
			pair < int , int > t = heap[1];
			heap[1].first = 1 << 30;
			del_top();
			cnt[ t.second ] = 0;
			
		//	for (i = 1; i <= f; i++)
		//		printf ( "%d %d\n" , heap[i].first , heap[i].second );
		//	printf ( "%d %d\n" , t.first , t.second );
		//	printf ( "\n" );
			
			for (i = 1; i <= m; i++)
				if ( !u[ t.second ][i] && !used[i] ) {
					u[ t.second ][i] = n;
					used[i] = 1;
					
					for (j = 1; j <= m; j++)
						if ( u[j][i] == 0 && cnt[j] ) {
							heap[ idx[j] ].first --;
							pop_up ( idx[j] );
						}
					break;
				}
		}
		
		for (i = 1; i <= m; i++)
			for (j = 1; j <= m; j++)
				if ( u[i][j] == n ) {
					printf ( "%d" , j );
					if ( i == m ) printf ( "\n" );
					else printf ( " " );
				}
	}
}

int main() {
	read();
	solve();
	
	return 0;
}
