#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

int n;
vector < int > st;
vector < int > ans;
int best;
int used[ 1 << 14 ];

void read() {
	scanf ( "%d" , &n );
}

void go ( int p , int r ) {
	st.push_back ( p );
	if ( (int)ans.size() < (int)st.size() ) 
		ans = st;
	if ( (double)clock() / (double)CLOCKS_PER_SEC > 4.5 ) return ;
	int i , j;
	int mask = 0;
	
	for (i = 0; i < min ( r + 1 , n ); i++) {
		if ( used[p ^ (1 << i)] ) continue;
		mask = 0;
		for (j = 0; j < n; j++) {
			mask |= used[p ^ (1 << j)] << j;
			used[p ^ (1 << j)] = 1;
		}
		
		go ( p ^ (1 << i) , max ( r , i + 1 ) );
		if ( (double)clock() / (double)CLOCKS_PER_SEC > 4.5 ) return ;
		
		for (j = 0; j < n; j++)
			used[p ^ (1 << j)] = !!(mask & (1 << j));
	}
	
	st.pop_back();
}

void solve() {
	int i;
	
	used[0] = 1;
	go ( 0 , 1 );
	
	printf ( "%d\n" , (int)ans.size() );
	for (i = 0; i < (int)ans.size(); i++) {
		for (int j = n; j --; ans[i] >>= 1)
			printf ( "%d " , ans[i] & 1 );
	
		printf ( "\n" );
	}
}

int main() {
	read();
	solve();
	
	return 0;
}
