#include <cstdio>
#include <vector>

const int MAX_N = 15;

const int mx[] = {1, 1, 2, 4, 7, 13, 26, 47, 82, 145, 245, 405, 769, 1454, 2702};

int N;

std :: vector<int> res;
int p[1 << MAX_N];
int d[1 << MAX_N];
bool used[1 << MAX_N];
bool change[MAX_N];

void print()
{
	printf("%d\n", res.size());
	for(int i = res.size() - 1; i >= 0; i --)
	{
		for(int j = N - 1; j >= 0; j --)
			printf("%d ", (res[i] & (1 << j)) != 0);
		printf("\n");
	}
}

void dfs(int v)
{
	if(d[v] + 1 > res.size())
	{
		res.clear();
		int vert = v;
		while(vert != -1)
		{
			res.push_back(vert);
			vert = p[vert];
		}
	}
	if(d[v] == mx[N])
	{
		print();
		exit(0);
	} 
	for(int i = 0; i < N; i ++)	if( !used[v ^ (1 << i)] )
	{
		int change = 0;
		for(int j = 0; j < N; j ++)	if(!used[v ^ (1 << j)])
		{
			used[v ^ (1 << j)] = 1;
			change |= 1 << j;
		}
		p[v ^ (1 << i)] = v;
		d[v ^ (1 << i)] = d[v] + 1;
		dfs(v ^ (1 << i));
		for(int j = 0; j < N; j ++)	if(change & (1 << j))
			used[v ^ (1 << j)] = 0;
	}
}

int main()
{
	scanf("%d", &N);
	used[0] = 1;
	p[0] = -1;
	dfs(0);
    return 0;
}
